// [PROJEKT] Wskaźnik promieniowania UV - KAMduino UNO, wyświetlacz EPAPER oraz czujnik UV
// Autor: Patryk Mądry
// Mikrokontroler.pl 2018
// Na podstawie przykładu 2.7inch e-paper display (B) demo (Yehui)

/**a
 *  @filename   :   epd2in7b-demo.ino
 *  @brief      :   2.7inch e-paper display (B) demo
 *  @author     :   Yehui from Waveshare
 *
 *  Copyright (C) Waveshare     July 17 2017
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documnetation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to  whom the Software is
 * furished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS OR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include <SPI.h>
#include <epd2in7b.h>
#include <epdpaint.h> 

#define COLORED     1
#define UNCOLORED   0

void setup() 
{
  Serial.begin(9600);
  Epd epd;
 
  if (epd.Init() != 0) 
  {
    Serial.print("Inicjalizacja nieprawidlowa! ");
    return;
  }

  epd.ClearFrame(); // czyszczenie pamięci SRAM wyswietlacza E-PAPER

  unsigned char image[1024];
  Paint paint(image, 176, 24);    //width should be the multiple of 8 

  paint.Clear(UNCOLORED);
  paint.DrawStringAt(0, 0, "MIKROKONTROLER.PL", &Font12, COLORED);
  epd.TransmitPartialBlack(paint.GetImage(), 32, 5, paint.GetWidth(), paint.GetHeight());

  
  paint.Clear(COLORED);
  paint.DrawStringAt(20, 2, "CZUJNIK UV", &Font20, UNCOLORED);
  epd.TransmitPartialRed(paint.GetImage(), 0, 50, paint.GetWidth(), paint.GetHeight());

  paint.Clear(UNCOLORED);
  paint.DrawStringAt(0, 0, "Indeks UV wynosi", &Font16, COLORED);
  epd.TransmitPartialBlack(paint.GetImage(), 0, 90, paint.GetWidth(), paint.GetHeight());

  int indeks_UV = 0;
  int wartosc_analogowa = 0;
  
  char tekst[10];
  char tekst2[10];
  
  
 // Pomiar 

  wartosc_analogowa = analogRead(A0);
  

  if (wartosc_analogowa <10)
  {
    indeks_UV  = 0;
  }
  else if (wartosc_analogowa >=10 && wartosc_analogowa <46 )
  {
    indeks_UV  = 1;
  }
  else if (wartosc_analogowa >=46 && wartosc_analogowa <65 )
  {
    indeks_UV  = 2;
  }
  else if (wartosc_analogowa >=65 && wartosc_analogowa <83 )
  {
    indeks_UV  = 3;
  }
  else if (wartosc_analogowa >=83 && wartosc_analogowa <103 )
  {
    indeks_UV  = 4;
  }
  else if (wartosc_analogowa >=103 && wartosc_analogowa <124 )
  {
    indeks_UV  = 5;
  }
  else if (wartosc_analogowa >=124 && wartosc_analogowa <142 )
  {
    indeks_UV  = 6;
  }
   else if (wartosc_analogowa >=142 && wartosc_analogowa <162 )
  {
    indeks_UV = 7;
  } 
   else if (wartosc_analogowa >=162 && wartosc_analogowa <180 )
  {
    indeks_UV = 8;
  } 
   else if (wartosc_analogowa >=180 && wartosc_analogowa <200 )
  {
    indeks_UV = 9;
  } 
  else if (wartosc_analogowa >=200 && wartosc_analogowa <221)
  {
    indeks_UV = 10;
  } 
  else if (wartosc_analogowa >=221)
  {
    indeks_UV = 11;
  } 
  
  
 
  sprintf(tekst,"%d", indeks_UV);
 

 

  paint.Clear(UNCOLORED);
  paint.DrawStringAt(0, 0, tekst, &Font24, COLORED);
  epd.TransmitPartialBlack(paint.GetImage(), 80, 120, paint.GetWidth(), paint.GetHeight());
  
  
 
   epd.DisplayFrame(); // Wyslanie informacji do wyswietlacza Epaper

   epd.Sleep();
  

}

void loop() {

  


}
